function PredCMP=RHC_Predictor_EA(k,xzero,xm1,xM1)
% It generates the predicted command profile (CMP) using EA
% Inputs: the initial moment of the prediction horizon (k), 
%              the initial state of the process (at moment k)
 % xm1, xM1 are the limits of the first control value
% Output: PredCMP is a vector having Nt-k elements (maximum 15 elements).

% str=sprintf('Selectie cu Stochastic Universal Sampling');disp(str);
% str=sprintf('Utilizare Rank si Scalare Rank');disp(str);
% str=sprintf('Replacement: in ultimele lambda pozitii');disp(str);
% str=sprintf('             din cele N ale populatiei');disp(str);
% str=sprintf('Incrucisare: Intr-un singur punct');disp(str);
% str=sprintf('             -produce un singur urmas');disp(str);
% str=sprintf('Mutatie: gaussiana adaptiva');disp(str);

%global uRHC;
global X0;
global Ncalls;
%global t_vector;
global Nt N;
global pop;
global CHILD;
global ngene NGen;
global xmin xmax xmin1 xmax1;
global fc fcCHILD;
global amic s;

global nr_fii;
global sigma msc mc;
%global X00;
J0=31.8; %Maximal value
N=35;   % N=nr de cromozomi din populatie
nr_fii=30;
NGen=70;     % NGen=nr de generatii
fc=zeros(N,1);
fcCHILD=zeros(nr_fii,1);

%h=Nt-k;
ngene=Nt-k;
%parinti=zeros(nr_fii,1);

s=1.8; %presiune de selectie
%str=sprintf('#####  N=%d nr_fii=%d NGen=%d s=%g',N, nr_fii, NGen, s);
%disp(str);
amic=0.85;

%X00=[0. 0. 1. 5. 1.];
xmin1=xm1;
xmax1=xM1;
X0=xzero;    
%Xk este starea initiala pe orizontul de predictie [k,Nt]
%stare(1,:)=X0; %memorare stare initiala

R=N:-1:1; % Rangurile populatiei. Solutiile sunt ordonate;
          % miu=N
P=ScaleRank(R,N,s);%P contine rangurile scalate
lambda=nr_fii;
pop=zeros(N,ngene);
CHILD=zeros(nr_fii,ngene);


%Generare populatie initiala
 for i=1:N  
    pop(i,1)=random('unif',xm1,xM1);
    for j=2:ngene     
          pop(i,j)=random('unif',xmin,xmax);
    end;
 end
 
%Evaluare initiala
for i=1:N
	[~,fc(i)]=eval_PR_step(pop(i,:),xzero);
 end

[fc,IX]=sort(fc,1,'descend');
 pop=pop(IX,:);
sigma=0.4;
mc=0;
msc=0;

g=1;
Ncalls=0;


gasit=0;
%CICLU MARE de T ITERAII
%tttttttttttttttttttttttttttttttttttttttttttttttttttttt BEGIN
while(g<=NGen)&&(gasit==0)
if (g==21)
    J0=J0-0.1;
    disp('                                                                                     ***  J0-0.1');
end
% SELECTIE PARINTI
parinti=StUnSamp(P,N,lambda);%indicii parintilor
per=randperm(lambda);
parinti=parinti(per);%permutare aleatorie a indicilor

%INCRUCISARE - atentie aici se construiesc (apar) fii
for ii=1:lambda
      jj=1;%randi(lambda);
      crossover2(parinti(ii),jj,ii); %un singur copil
      %se incruciseaza pop(parinti(ii),:) cu alt cromozom din lista          
end
%------------------------------
 %MUTATIE (mutatieGaussRH contine si evaluarea)
 for iii=1:lambda
      [~,fcCHILD(iii)]=eval_PR_step(CHILD(iii,:),xzero);
      
      %Evalure inainte de mutatie pt toti fii
      %(valabila si daca nu voi face mutatie);
      
      daca_mut=randi(100);
      if(daca_mut<=90)      
        mutatieGauss5(iii,xzero); %Fac mutatie pe CHILD(iii)
        
      end
 end

 % Copiere fii pe ultimele lambda POZITII din cele N
 pop((N-lambda+1):N,:)=CHILD;
 fc((N-lambda+1):N)=fcCHILD;
 %------------------------------------
 % Reordonare pop dupa fc
 [fc,IX]=sort(fc,1,'descend');
 pop=pop(IX,:);   %reordoneaza
 %Convergence test
 if (fc(1)>J0)
     gasit=1;
 end
 
%  if (mod(g,10)==0)
%     str=sprintf('#####   nr. gen=%g sigma= %g Jmax=%g',g, sigma,fc(1));
%     disp(str);
%  end
 %------------------------------------
 

g=g+1;

end     %CICLU MARE (dupa g)-while
%tttttttttttttttttttttttttttttttttttttttttttttttttttttt END
%tttttttttttttttttttttttttttttttttttttttttttttttttttttt END
    
    str=sprintf('#   nr. gen=%g Jmax=%g, Ncalls=%5d',g,fc(1), Ncalls);
    disp(str);
PredCMP=pop(1,:);

end