% Protein Production-5 states
% RHC without ESTMATOR 
% AUTOMATION 2- typical run and drawing

global Nt;
global X00;
t_fin=15;
Nt=15;
global u_vector % vector global cu eval_fi 
global t_vector % vector global cu prog principal
global command_index;
load('WSPmod0.mat','UstarRHC','X15','JMAT','NcallsC');
str=sprintf('Indicele de performanta mediu este: %g \n',mean(JMAT));
disp(str);
DJ=JMAT-mean(JMAT);
i0=1;
for i=2:30
    if(abs(DJ(i))<abs(DJ(i0)))
        i0=i;
    end
end

X00=[0. 0. 1. 5. 1.];
ustar=UstarRHC(i0,:);

%Afisare evolutie sistem in executie tipica
t=0:1:Nt; %are Nt+1 elemente

str=sprintf('Typical execution:\n\n');disp(str);
disp('i0=');disp(i0);

str=sprintf('Jtypical = %6.4f\n',JMAT(i0));disp(str);
str=sprintf('Xf1=%6.4f Xf5=%6.4f\n',X15(i0,1),X15(i0,2));disp(str);

Minim=min(JMAT);
[Maxim,imax]=max(JMAT);
Var=var(JMAT);
str=sprintf('Minim=%7.4f \nMaxim=%7.4f,\nvarianta=%g\n',...
    Minim,Maxim,Var);disp(str);

%**************************************************************
%Global simulation
u_vector=[ustar(1:Nt),ustar(Nt)];
t_vector=0:t_fin;
figure(4)
stairs(t_vector,u_vector,'r');
title('Typical profile control - without Estimator');
xlabel('time [h]');
ylabel('control output: u ');
axis([0,15,0.,2.]);
grid MINOR;


command_index=1;
%options = odeset('RelTol',1e-3,'MaxStep',1.5);
[T,Y] = ode23('PRProd',t_vector,X00);
J1=Y(end,1)*Y(end,5);
disp(J1);

figure(5)
plot(T,3*Y(:,1),'r',T,3*Y(:,2),'k',T,3*Y(:,3),'g',T,Y(:,4),'-.b',T,Y(:,5),'m');
title('RHC-loop: State evolution ');
axis([0,15,0.,14.]);
xlabel('time [h]');
ylabel('state variables');
legend('\it{3x}_{1}','\it{3x}_{2}','\it{3x}_{3}','\it{x}_{4}','\it{x}_{5}','Location','NorthWest');

text(6.,9.,'J_{typical}=31.9','FontSize',12);
grid MINOR;
%**********************

%Data for Table 1 and 2
for i=1:30
    str=sprintf('%7.0f',NcallsC(i)/15);disp(str);
end

for i=1:30
    str=sprintf('%4.2f',JMAT(i));disp(str)
end
for i=1:30
    str=sprintf('%4.2f',X15(i,1));disp(str);
end
for i=1:30
    str=sprintf('%4.2f',X15(i,2));disp(str);
end
